/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-18 at 01:29:21 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.books.model;

/**
 * Model definition for AnnotationsSummary.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class AnnotationsSummary extends com.google.api.client.json.GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Layers> layers;

  static {
    // hack to force ProGuard to consider Layers used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Layers.class);
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * @param kind kind or {@code null} for none
   */
  public AnnotationsSummary setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.util.List<Layers> getLayers() {
    return layers;
  }

  /**
   * @param layers layers or {@code null} for none
   */
  public AnnotationsSummary setLayers(java.util.List<Layers> layers) {
    this.layers = layers;
    return this;
  }

  @Override
  public AnnotationsSummary set(String fieldName, Object value) {
    return (AnnotationsSummary) super.set(fieldName, value);
  }

  @Override
  public AnnotationsSummary clone() {
    return (AnnotationsSummary) super.clone();
  }

  /**
   * Model definition for AnnotationsSummaryLayers.
   */
  public static final class Layers extends com.google.api.client.json.GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer allowedCharacterCount;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String layerId;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String limitType;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer remainingCharacterCount;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private com.google.api.client.util.DateTime updated;

    /**
     * @return value or {@code null} for none
     */
    public java.lang.Integer getAllowedCharacterCount() {
      return allowedCharacterCount;
    }

    /**
     * @param allowedCharacterCount allowedCharacterCount or {@code null} for none
     */
    public Layers setAllowedCharacterCount(java.lang.Integer allowedCharacterCount) {
      this.allowedCharacterCount = allowedCharacterCount;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getLayerId() {
      return layerId;
    }

    /**
     * @param layerId layerId or {@code null} for none
     */
    public Layers setLayerId(java.lang.String layerId) {
      this.layerId = layerId;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getLimitType() {
      return limitType;
    }

    /**
     * @param limitType limitType or {@code null} for none
     */
    public Layers setLimitType(java.lang.String limitType) {
      this.limitType = limitType;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.Integer getRemainingCharacterCount() {
      return remainingCharacterCount;
    }

    /**
     * @param remainingCharacterCount remainingCharacterCount or {@code null} for none
     */
    public Layers setRemainingCharacterCount(java.lang.Integer remainingCharacterCount) {
      this.remainingCharacterCount = remainingCharacterCount;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public com.google.api.client.util.DateTime getUpdated() {
      return updated;
    }

    /**
     * @param updated updated or {@code null} for none
     */
    public Layers setUpdated(com.google.api.client.util.DateTime updated) {
      this.updated = updated;
      return this;
    }

    @Override
    public Layers set(String fieldName, Object value) {
      return (Layers) super.set(fieldName, value);
    }

    @Override
    public Layers clone() {
      return (Layers) super.clone();
    }

  }

}
